## etcd 3.5.15

=== debian/changelog ===
etcd (3.5.15-7) unstable; urgency=medium

  * Team upload.
  * Fix autopkgtests, Closes: #1077867
    - Disable curl-related-tests
    - debian/tests/functional: Patch functional.yaml for
      non-standard port-numbers

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 08 Aug 2024 19:24:08 -0400

etcd (3.5.15-6) unstable; urgency=medium

  * Team upload.
  * Mark autopkgtests 'functional' and 'integration' as flaky
    to aid testing migration

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 03 Aug 2024 09:53:51 -0400

etcd (3.5.15-5) unstable; urgency=medium

  * Team upload

  [ Mathias Gibbens ]
  * Include most of tests/ directory as other packages FTBFS without
    those sources
  * Restore coreos symlink created by d/golang-etcd-server-dev.links

  [ Reinhard Tartler ]
  * tests/functional: Make etcdutl available
  * Avoid dangling symlinks in the -dev package

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 03 Aug 2024 04:48:17 +0000

etcd (3.5.15-4) unstable; urgency=medium

  * Drop v3 symlink and install go.mod file
  * Ignore etcd package without v3 suffix when checking leaking goroutines.
  * Run short test during build
  * Drop unused Depends
    - golang-github-coreos-pkg-dev
    - golang-github-google-uuid-dev
  * Ingore contrib dir when building
  * Fix functional and integration autopkgtest

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 01 Aug 2024 16:25:53 +0800

etcd (3.5.15-3) unstable; urgency=medium

  * Team upload
  * d/control:
    - Update list of Breaks in d/control to help hint through migration
    - Update minimum version of various libraries in Build-Depends and Depends
  * Add symlinks in d/golang-etcd-server-dev.links to mimic go.mod's replace
  * Add patch to skip test that fails in salsa CI pipeline

 -- Mathias Gibbens <gibmat@debian.org>  Tue, 30 Jul 2024 07:16:48 +0000

etcd (3.5.15-2) unstable; urgency=medium

  * Team upload
  * Fix FTBFS due to grpc-middleware v2 API changes
    - Cherry-pick upstream changes with fixes
    - Add patch to rip some usage out of a test

 -- Mathias Gibbens <gibmat@debian.org>  Mon, 29 Jul 2024 04:53:56 +0000

etcd (3.5.15-1) unstable; urgency=medium

  [ Mathias Gibbens ]
  * Team upload
  * New upstream release (Closes: #991462)
    - Rebase existing patches
  * d/control:
    - Update Build-Depends and Depends

  [ Reinhard Tartler ]
  * Backport code changes to build against newer grpc-gateway
  * fix zap logger invocation
  * only run the short tests
  * ignore mvcc/backend and api/membership
  * Rename etcd executable and fix package installation

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 28 Jul 2024 15:26:05 -0400

etcd (3.4.30-3) experimental; urgency=medium

  * Team upload.
  * compile against grpc 1.64 and grpc-gateway@v2

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 29 Jun 2024 17:18:45 -0400

etcd (3.4.30-2) experimental; urgency=medium

  * Team upload.
  * build against golang/protobuf@v1.5

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 09 Jun 2024 15:40:28 -0400

=== debian/control ===
Source: etcd
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Jelmer Vernooij <jelmer@debian.org>,
           Tim Potter <tpot@hpe.com>,
           Anthony Fok <foka@debian.org>,
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any (>= 2:1.10~),
               golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
               golang-github-cockroachdb-datadriven-dev,
               golang-github-coreos-bbolt-dev,
               golang-github-coreos-go-semver-dev (>= 0.2.0~),
               golang-github-coreos-go-systemd-dev,
               golang-github-creack-pty-dev (>= 1.1.11~),
               golang-github-dustin-go-humanize-dev,
               golang-github-gogo-protobuf-dev,
               golang-github-golang-groupcache-dev (>= 0.0~git20160516.0.02826c3~),
               golang-github-golang-jwt-jwt-dev,
               golang-github-golang-protobuf-1-5-dev,
               golang-github-google-btree-dev,
               golang-github-grpc-ecosystem-go-grpc-middleware-dev (>= 2.0),
               golang-github-grpc-ecosystem-go-grpc-prometheus-dev (>= 1.2.0+git20191002.6af20e3-5),
               golang-github-grpc-ecosystem-grpc-gateway-dev (>= 2.0),
               golang-github-jonboulle-clockwork-dev,
               golang-github-json-iterator-go-dev,
               golang-github-modern-go-reflect2-dev,
               golang-github-olekukonko-tablewriter-dev (>= 0.0~git20170122.0.a0225b3~),
               golang-github-prometheus-client-golang-dev (>= 1.0.0~),
               golang-github-prometheus-client-model-dev,
               golang-github-soheilhy-cmux-dev,
               golang-github-spf13-cobra-dev,
               golang-github-spf13-pflag-dev,
               golang-github-stretchr-testify-dev,
               golang-github-tmc-grpc-websocket-proxy-dev,
               golang-github-urfave-cli-dev,
               golang-github-xiang90-probing-dev (>= 0.0.1~),
               golang-go.uber-zap-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-time-dev,
               golang-golang-x-tools,
               golang-google-grpc-dev (>= 1.64.0-5),
               golang-gopkg-cheggaaa-pb.v1-dev,
               golang-gopkg-natefinch-lumberjack.v2-dev,
               golang-gopkg-yaml.v2-dev,
               golang-k8s-sigs-yaml-dev,
               golang-opentelemetry-contrib-dev,
               golang-opentelemetry-otel-dev (>= 1.21.0),
               protoc-gen-go-1-5,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/etcd
Vcs-Git: https://salsa.debian.org/go-team/packages/etcd.git
Homepage: https://etcd.io
Rules-Requires-Root: no
XS-Go-Import-Path: go.etcd.io/etcd,
                   github.com/coreos/etcd
Testsuite: autopkgtest-pkg-go

Package: etcd-server
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: etcd-client,
Built-Using: ${misc:Built-Using},
Description: highly-available key value store -- daemon
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the server binaries.

Package: etcd-client
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Built-Using: ${misc:Built-Using},
Description: highly-available key value store -- client
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the client binaries.

Package: golang-etcd-server-dev
Architecture: all
Depends: golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
         golang-github-cockroachdb-datadriven-dev,
         golang-github-coreos-bbolt-dev,
         golang-github-coreos-go-semver-dev (>= 0.2.0~),
         golang-github-coreos-go-systemd-dev,
         golang-github-creack-pty-dev (>= 1.1.11~),
         golang-github-dustin-go-humanize-dev,
         golang-github-gogo-protobuf-dev,
         golang-github-golang-groupcache-dev (>= 0.0~git20160516.0.02826c3~),
         golang-github-golang-jwt-jwt-dev,
         golang-github-golang-protobuf-1-5-dev,
         golang-github-google-btree-dev,
         golang-github-grpc-ecosystem-go-grpc-middleware-dev (>= 2.0),
         golang-github-grpc-ecosystem-go-grpc-prometheus-dev (>= 1.2.0+git20191002.6af20e3-5),
         golang-github-grpc-ecosystem-grpc-gateway-dev (>= 2.0),
         golang-github-jonboulle-clockwork-dev,
         golang-github-json-iterator-go-dev,
         golang-github-modern-go-reflect2-dev,
         golang-github-olekukonko-tablewriter-dev (>= 0.0~git20170122.0.a0225b3~),
         golang-github-prometheus-client-golang-dev (>= 1.0.0~),
         golang-github-prometheus-client-model-dev,
         golang-github-soheilhy-cmux-dev,
         golang-github-spf13-cobra-dev,
         golang-github-spf13-pflag-dev,
         golang-github-tmc-grpc-websocket-proxy-dev,
         golang-github-urfave-cli-dev,
         golang-github-xiang90-probing-dev (>= 0.0.1~),
         golang-go.uber-zap-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-time-dev,
         golang-google-grpc-dev (>= 1.64.0-5),
         golang-gopkg-cheggaaa-pb.v1-dev,
         golang-gopkg-natefinch-lumberjack.v2-dev,
         golang-gopkg-yaml.v2-dev,
         golang-k8s-sigs-yaml-dev,
         golang-opentelemetry-contrib-dev,
         golang-opentelemetry-otel-dev (>= 1.21.0),
         ${misc:Depends},
Provides: golang-github-coreos-etcd-dev,
Breaks: golang-github-docker-docker-dev (<< 20.10.21+dfsg1-2~),
        golang-github-docker-libkv-dev (<< 0.2.1-4),
        golang-github-go-kit-kit-dev (<< 0.13.0-1),
        golang-github-minio-pkg-dev (<< 3.0.9-2),
        golang-github-xordataexchange-crypt-dev (<< 0.0.2+git20170626.21.b2862e3-4),
        nextcloud-spreed-signaling (<< 0.4.1-3~),
        vip-manager (<<1.0.2-5~),
Description: highly-available key value store -- source
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the source.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_EXCLUDES := tools tests/functional/cmd contrib
export DH_GOLANG_INSTALL_EXTRA := $(shell find . -name fixtures-expired) \
                                  $(shell find . -name fixtures) \
                                  $(shell find . -name go.mod) \
                                  tests/functional/functional.yaml

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

execute_after_dh_auto_build:
	mv -v _build/bin/server _build/bin/etcd
    # remove dangling symlinks. They are pointing to the "tests" package that
    # we exclude further up
	rm -vf _build/src/go.etcd.io/etcd/client/*/example_*.go

override_dh_auto_test:
	GOLANG_TEST_SHORT=true dh_auto_test -O--no-parallel -- -run=Test -short

execute_after_dh_auto_test:
	find _build -type s -delete

# Handle package name (etcd-server) != service name (etcd)
override_dh_installinit:
	dh_installinit -p etcd-server --name=etcd
override_dh_installsystemd:
	dh_installsystemd -p etcd-server --name=etcd

# autopktest-pkg-go integration runs "debian/rules build", which is a no-op due
# to a script "build" present in the upstream source. This (PHONY) target
# overrides this.
build:
	dh build --buildsystem=golang --with=golang --builddirectory=_build

.PHONY: build

=== debian/tests/control ===
Tests: integration
Architecture: amd64
Depends: curl,
         procps,
         etcd-client,
         etcd-server,
         @builddeps@,
Restrictions: allow-stderr, needs-root, breaks-testbed, isolation-container, flaky

Tests: functional
Architecture: amd64
Depends: etcd-client,
         etcd-server,
         netcat-openbsd,
         iproute2,
         @builddeps@,
Restrictions: allow-stderr, isolation-container, flaky

## etcd 3.5.16

=== Makefile ===
# run from repository root



# Example:
#   make build
#   make clean
#   make docker-clean
#   make docker-start
#   make docker-kill
#   make docker-remove

UNAME := $(shell uname)
XARGS = xargs
ARCH ?= $(shell go env GOARCH)

# -r is only necessary on GNU xargs.
ifeq ($(UNAME), Linux)
XARGS += -r
endif
XARGS += rm -r

.PHONY: build
build:
	GO_BUILD_FLAGS="-v" ./build.sh
	./bin/etcd --version
	./bin/etcdctl version
	./bin/etcdutl version

clean:
	rm -f ./codecov
	rm -rf ./covdir
	rm -f ./bin/Dockerfile-release*
	rm -rf ./bin/etcd*
	rm -rf ./default.etcd
	rm -rf ./tests/e2e/default.etcd
	rm -rf ./release
	rm -rf ./coverage/*.err ./coverage/*.out
	rm -rf ./tests/e2e/default.proxy
	rm -rf ./bin/shellcheck*
	find ./ -name "127.0.0.1:*" -o -name "localhost:*" -o -name "*.log" -o -name "agent-*" -o -name "*.coverprofile" -o -name "testname-proxy-*" | $(XARGS)

docker-clean:
	docker images
	docker image prune --force

docker-start:
	service docker restart

docker-kill:
	docker kill `docker ps -q` || true

docker-remove:
	docker rm --force `docker ps -a -q` || true
	docker rmi --force `docker images -q` || true



GO_VERSION ?= $(shell cat .go-version)
ETCD_VERSION ?= $(shell git rev-parse --short HEAD || echo "GitNotFound")

TEST_SUFFIX = $(shell date +%s | base64 | head -c 15)
TEST_OPTS ?= PASSES='unit'

TMP_DIR_MOUNT_FLAG = --tmpfs=/tmp:exec
ifdef HOST_TMP_DIR
	TMP_DIR_MOUNT_FLAG = --mount type=bind,source=$(HOST_TMP_DIR),destination=/tmp
endif


TMP_DOCKERFILE:=$(shell mktemp)

# Example:
#   GO_VERSION=1.14.3 make build-docker-test
#   make build-docker-test
#
#   gcloud auth configure-docker
#   GO_VERSION=1.14.3 make push-docker-test
#   make push-docker-test
#
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com
#   make pull-docker-test

build-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	@sed 's|REPLACE_ME_GO_VERSION|$(GO_VERSION)|g' ./tests/Dockerfile > $(TMP_DOCKERFILE)
	docker build \
	  --network=host \
	  --tag gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
	  --file $(TMP_DOCKERFILE) .

push-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker push gcr.io/etcd-development/etcd-test:go$(GO_VERSION)

pull-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker pull gcr.io/etcd-development/etcd-test:go$(GO_VERSION)



# Example:
#   make build-docker-test
#   make compile-with-docker-test
#   make compile-setup-gopath-with-docker-test

compile-with-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker run \
	  --rm \
	  --mount type=bind,source=`pwd`,destination=/go/src/go.etcd.io/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
	  /bin/bash -c "GO_BUILD_FLAGS=-v GOOS=linux GOARCH=amd64 ./build.sh && ./bin/etcd --version"

compile-setup-gopath-with-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker run \
	  --rm \
	  --mount type=bind,source=`pwd`,destination=/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && ETCD_SETUP_GOPATH=1 GO_BUILD_FLAGS=-v GOOS=linux GOARCH=amd64 ./build.sh && ./bin/etcd --version && rm -rf ./gopath"



# Example:
#
# Local machine:
#   TEST_OPTS="PASSES='fmt'" make test
#   TEST_OPTS="PASSES='fmt bom dep build unit'" make test
#   TEST_OPTS="PASSES='build unit release integration_e2e functional'" make test
#   TEST_OPTS="PASSES='build grpcproxy'" make test
#
# Example (test with docker):
#   make pull-docker-test
#   TEST_OPTS="PASSES='fmt'" make docker-test
#   TEST_OPTS="VERBOSE=2 PASSES='unit'" make docker-test
#
# Travis CI (test with docker):
#   TEST_OPTS="PASSES='fmt bom dep build unit'" make docker-test
#
# Semaphore CI (test with docker):
#   TEST_OPTS="PASSES='build unit release integration_e2e functional'" make docker-test
#   HOST_TMP_DIR=/tmp TEST_OPTS="PASSES='build unit release integration_e2e functional'" make docker-test
#   TEST_OPTS="GOARCH=386 PASSES='build unit integration_e2e'" make docker-test
#
# grpc-proxy tests (test with docker):
#   TEST_OPTS="PASSES='build grpcproxy'" make docker-test
#   HOST_TMP_DIR=/tmp TEST_OPTS="PASSES='build grpcproxy'" make docker-test

.PHONY: test
test:
	$(info TEST_OPTS: $(TEST_OPTS))
	$(info log-file: test-$(TEST_SUFFIX).log)
	$(TEST_OPTS) ./test.sh 2>&1 | tee test-$(TEST_SUFFIX).log
	! egrep "(--- FAIL:|DATA RACE|panic: test timed out|appears to have leaked)" -B50 -A10 test-$(TEST_SUFFIX).log

test-smoke:
	$(info log-file: test-$(TEST_SUFFIX).log)
	PASSES="fmt bom dep build unit" ./test.sh 2<&1 | tee test-$(TEST_SUFFIX).log
	! grep "FAIL:" test-$(TEST_SUFFIX).log

test-full:
	$(info log-file: test-$(TEST_SUFFIX).log)
	PASSES="fmt build release unit integration functional e2e grpcproxy" ./test.sh 2<&1 | tee test-$(TEST_SUFFIX).log

.PHONY: test-unit
test-unit:
	PASSES="unit" ./test.sh $(GO_TEST_FLAGS)

.PHONY: test-integration
test-integration:
	PASSES="integration" ./test.sh $(GO_TEST_FLAGS)

.PHONY: test-e2e
test-e2e:
	PASSES="build e2e" ./test.sh $(GO_TEST_FLAGS)

.PHONY: test-e2e-release
test-e2e-release:
	PASSES="build release e2e" ./test.sh $(GO_TEST_FLAGS)

ensure-docker-test-image-exists:
	make pull-docker-test || ( echo "WARNING: Container Image not found in registry, building locally"; make build-docker-test )

docker-test: ensure-docker-test-image-exists
	$(info GO_VERSION: $(GO_VERSION))
	$(info ETCD_VERSION: $(ETCD_VERSION))
	$(info TEST_OPTS: $(TEST_OPTS))
	$(info log-file: test-$(TEST_SUFFIX).log)
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`,destination=/go/src/go.etcd.io/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
	  /bin/bash -c "$(TEST_OPTS) ./test.sh 2>&1 | tee test-$(TEST_SUFFIX).log"
	! egrep "(--- FAIL:|DATA RACE|panic: test timed out|appears to have leaked)" -B50 -A10 test-$(TEST_SUFFIX).log

docker-test-coverage:
	$(info GO_VERSION: $(GO_VERSION))
	$(info ETCD_VERSION: $(ETCD_VERSION))
	$(info log-file: docker-test-coverage-$(TEST_SUFFIX).log)
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`,destination=/go/src/go.etcd.io/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
	  /bin/bash ./scripts/codecov_upload.sh docker-test-coverage-$(TEST_SUFFIX).log \
	! egrep "(--- FAIL:|DATA RACE|panic: test timed out|appears to have leaked)" -B50 -A10 docker-test-coverage-$(TEST_SUFFIX).log



# Example:
#   make compile-with-docker-test
#   ETCD_VERSION=v3-test make build-docker-release-main
#   ETCD_VERSION=v3-test make push-docker-release-main
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com

build-docker-release-main:
	$(info ETCD_VERSION: $(ETCD_VERSION))
	cp ./Dockerfile-release.$(ARCH) ./bin/Dockerfile-release.$(ARCH)
	docker build \
	  --network=host \
	  --tag gcr.io/etcd-development/etcd:$(ETCD_VERSION) \
	  --file ./bin/Dockerfile-release.$(ARCH) \
	  ./bin
	rm -f ./bin/Dockerfile-release.$(ARCH)

	docker run \
	  --rm \
	  gcr.io/etcd-development/etcd:$(ETCD_VERSION) \
	  /bin/sh -c "/usr/local/bin/etcd --version && /usr/local/bin/etcdctl version && /usr/local/bin/etcdutl version"

push-docker-release-main:
	$(info ETCD_VERSION: $(ETCD_VERSION))
	docker push gcr.io/etcd-development/etcd:$(ETCD_VERSION)



# Example:
#   make build-docker-test
#   make compile-with-docker-test
#   make build-docker-static-ip-test
#
#   gcloud auth configure-docker
#   make push-docker-static-ip-test
#
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com
#   make pull-docker-static-ip-test
#
#   make docker-static-ip-test-certs-run
#   make docker-static-ip-test-certs-metrics-proxy-run

build-docker-static-ip-test:
	$(info GO_VERSION: $(GO_VERSION))
	@sed 's|REPLACE_ME_GO_VERSION|$(GO_VERSION)|g' ./tests/docker-static-ip/Dockerfile > $(TMP_DOCKERFILE)
	docker build \
	  --network=host \
	  --tag gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION) \
	  --file ./tests/docker-static-ip/Dockerfile \
	  $(TMP_DOCKERFILE)

push-docker-static-ip-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker push gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION)

pull-docker-static-ip-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker pull gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION)

docker-static-ip-test-certs-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-static-ip/certs,destination=/certs \
	  gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /certs/run.sh && rm -rf m*.etcd"

docker-static-ip-test-certs-metrics-proxy-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-static-ip/certs-metrics-proxy,destination=/certs-metrics-proxy \
	  gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /certs-metrics-proxy/run.sh && rm -rf m*.etcd"



# Example:
#   make build-docker-test
#   make compile-with-docker-test
#   make build-docker-dns-test
#
#   gcloud auth configure-docker
#   make push-docker-dns-test
#
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com
#   make pull-docker-dns-test
#
#   make docker-dns-test-insecure-run
#   make docker-dns-test-certs-run
#   make docker-dns-test-certs-gateway-run
#   make docker-dns-test-certs-wildcard-run
#   make docker-dns-test-certs-common-name-auth-run
#   make docker-dns-test-certs-common-name-multi-run
#   make docker-dns-test-certs-san-dns-run

build-docker-dns-test:
	$(info GO_VERSION: $(GO_VERSION))
	@sed 's|REPLACE_ME_GO_VERSION|$(GO_VERSION)|g' ./tests/docker-dns/Dockerfile > $(TMP_DOCKERFILE)
	docker build \
	  --network=host \
	  --tag gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  --file ./tests/docker-dns/Dockerfile \
	  $(TMP_DOCKERFILE)

	docker run \
	  --rm \
	  --dns 127.0.0.1 \
	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  /bin/bash -c "/etc/init.d/bind9 start && cat /dev/null >/etc/hosts && dig etcd.local"

push-docker-dns-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker push gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION)

pull-docker-dns-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker pull gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION)

docker-dns-test-insecure-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  --dns 127.0.0.1 \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-dns/insecure,destination=/insecure \
	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /insecure/run.sh && rm -rf m*.etcd"

docker-dns-test-certs-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  --dns 127.0.0.1 \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-dns/certs,destination=/certs \
	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /certs/run.sh && rm -rf m*.etcd"

docker-dns-test-certs-gateway-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  --dns 127.0.0.1 \

=== hack/tls-setup/Makefile ===
.PHONY: cfssl ca req clean

CFSSL	= @env PATH=$(GOPATH)/bin:$(PATH) cfssl
JSON	= env PATH=$(GOPATH)/bin:$(PATH) cfssljson

all:  ca req

cfssl:
	HTTPS_PROXY=127.0.0.1:12639 go get -u -tags nopkcs11 github.com/cloudflare/cfssl/cmd/cfssl
	HTTPS_PROXY=127.0.0.1:12639 go get -u github.com/cloudflare/cfssl/cmd/cfssljson
	HTTPS_PROXY=127.0.0.1:12639 go get -u github.com/mattn/goreman

ca:
	mkdir -p certs
	$(CFSSL) gencert -initca config/ca-csr.json | $(JSON) -bare certs/ca

req:
	$(CFSSL) gencert \
	  -ca certs/ca.pem \
	  -ca-key certs/ca-key.pem \
	  -config config/ca-config.json \
	  config/req-csr.json | $(JSON) -bare certs/${infra0}
	$(CFSSL) gencert \
	  -ca certs/ca.pem \
	  -ca-key certs/ca-key.pem \
	  -config config/ca-config.json \
	  config/req-csr.json | $(JSON) -bare certs/${infra1}
	$(CFSSL) gencert \
	  -ca certs/ca.pem \
	  -ca-key certs/ca-key.pem \
	  -config config/ca-config.json \
	  config/req-csr.json | $(JSON) -bare certs/${infra2}
	$(CFSSL) gencert \
	  -ca certs/ca.pem \
	  -ca-key certs/ca-key.pem \
	  -config config/ca-config.json \
	  config/req-csr.json | $(JSON) -bare certs/peer-${infra0}
	$(CFSSL) gencert \
	  -ca certs/ca.pem \
	  -ca-key certs/ca-key.pem \
	  -config config/ca-config.json \
	  config/req-csr.json | $(JSON) -bare certs/peer-${infra1}
	$(CFSSL) gencert \
	  -ca certs/ca.pem \
	  -ca-key certs/ca-key.pem \
	  -config config/ca-config.json \
	  config/req-csr.json | $(JSON) -bare certs/peer-${infra2}

clean:
	rm -rf certs

=== debian/changelog ===
etcd (3.5.16-8) unstable; urgency=medium

  * Team upload.
  * Fix compilation with golang 1.25.2, Closes: #1117747
  * debian/tests/control: require container-isolation for 'member-list'

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 12 Oct 2025 06:57:05 -0400

etcd (3.5.16-7) unstable; urgency=medium

  * Team upload.
  * Tighten dependency on golang-github-olekukonko-tablewriter-dev

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 18 Aug 2025 08:11:39 -0400

etcd (3.5.16-6) unstable; urgency=medium

  * Team upload.
  * Mark autopkgtests as non-optional
  * Unbreak autopkgtest 'member-list' (allows stderr)

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 17 Aug 2025 13:14:50 -0400

etcd (3.5.16-5) unstable; urgency=medium

  * Team upload.
  * debian/copyright: drop Files-Excluded
  * add new and quick test for autopkgtest
  * Drop init script
  * dependency: bump github.com/olekukonko/tablewriter from 0.0.5 to 1.0.6

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 17 Aug 2025 09:20:41 -0400

etcd (3.5.16-4) unstable; urgency=medium

  * Team upload.

  [ Nicolas Peugnet ]
  * Add patch to fix tests with go 1.24. (Closes: #1096215)

  [ Guillem Jover ]
  * Run wrap-and-sort -ast.
  * Switch from Built-Using to Static-Built-Using field.
  * Switch to Standards-Version 4.7.2 (no changes needed).
  * Place each make variable multi-value into its own line.
  * Update debian/gbp.conf with Go Team current workflow.
  * Switch from dh-golang to dh-sequence-goland and no explicit --with=golang.
  * Lowercase man pages command name in title.
  * Update copyright years.

 -- Guillem Jover <gjover@sipwise.com>  Tue, 04 Mar 2025 14:20:11 +0100

etcd (3.5.16-3) unstable; urgency=medium

  * Team upload.
  * TestHashKVWhenCompacting: increase timeout 10s->15s to avoid
    build failures on armel, and potentially other slower platforms

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 01 Nov 2024 05:38:59 -0400

etcd (3.5.16-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 31 Oct 2024 06:24:51 -0400

etcd (3.5.16-1) experimental; urgency=medium

  * Team upload.
  * New upstream release: 3.5.16
  * Tighten dependencies on opentelemetry packages

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 21 Oct 2024 16:30:05 -0400

=== debian/control ===
Source: etcd
Section: net
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Jelmer Vernooij <jelmer@debian.org>,
 Tim Potter <tpot@hpe.com>,
 Anthony Fok <foka@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 golang-any (>= 2:1.10~),
 golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
 golang-github-cockroachdb-datadriven-dev,
 golang-github-coreos-bbolt-dev,
 golang-github-coreos-go-semver-dev (>= 0.2.0~),
 golang-github-coreos-go-systemd-dev,
 golang-github-creack-pty-dev (>= 1.1.11~),
 golang-github-dustin-go-humanize-dev,
 golang-github-gogo-protobuf-dev,
 golang-github-golang-groupcache-dev (>= 0.0~git20160516.0.02826c3~),
 golang-github-golang-jwt-jwt-dev,
 golang-github-golang-protobuf-1-5-dev,
 golang-github-google-btree-dev,
 golang-github-grpc-ecosystem-go-grpc-middleware-dev (>= 2.0),
 golang-github-grpc-ecosystem-go-grpc-prometheus-dev (>= 1.2.0+git20191002.6af20e3-5),
 golang-github-grpc-ecosystem-grpc-gateway-dev (>= 2.0),
 golang-github-jonboulle-clockwork-dev,
 golang-github-json-iterator-go-dev,
 golang-github-modern-go-reflect2-dev,
 golang-github-olekukonko-tablewriter-dev (>= 1.0),
 golang-github-prometheus-client-golang-dev (>= 1.0.0~),
 golang-github-prometheus-client-model-dev,
 golang-github-soheilhy-cmux-dev,
 golang-github-spf13-cobra-dev,
 golang-github-spf13-pflag-dev,
 golang-github-stretchr-testify-dev,
 golang-github-tmc-grpc-websocket-proxy-dev,
 golang-github-urfave-cli-dev,
 golang-github-xiang90-probing-dev (>= 0.0.1~),
 golang-go.uber-zap-dev,
 golang-golang-x-crypto-dev,
 golang-golang-x-net-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-time-dev,
 golang-golang-x-tools,
 golang-google-grpc-dev (>= 1.64.0-5),
 golang-gopkg-cheggaaa-pb.v1-dev,
 golang-gopkg-natefinch-lumberjack.v2-dev,
 golang-gopkg-yaml.v2-dev,
 golang-k8s-sigs-yaml-dev,
 golang-opentelemetry-contrib-dev (>= 0.56),
 golang-opentelemetry-otel-dev (>= 1.31),
 protoc-gen-go-1-5,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/etcd
Vcs-Git: https://salsa.debian.org/go-team/packages/etcd.git
Homepage: https://etcd.io
XS-Go-Import-Path: go.etcd.io/etcd, github.com/coreos/etcd

Package: etcd-server
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 etcd-client,
Static-Built-Using:
 ${misc:Static-Built-Using},
Description: highly-available key value store -- daemon
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the server binaries.

Package: etcd-client
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Static-Built-Using:
 ${misc:Static-Built-Using},
Description: highly-available key value store -- client
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the client binaries.

Package: golang-etcd-server-dev
Architecture: all
Depends:
 golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
 golang-github-cockroachdb-datadriven-dev,
 golang-github-coreos-bbolt-dev,
 golang-github-coreos-go-semver-dev (>= 0.2.0~),
 golang-github-coreos-go-systemd-dev,
 golang-github-creack-pty-dev (>= 1.1.11~),
 golang-github-dustin-go-humanize-dev,
 golang-github-gogo-protobuf-dev,
 golang-github-golang-groupcache-dev (>= 0.0~git20160516.0.02826c3~),
 golang-github-golang-jwt-jwt-dev,
 golang-github-golang-protobuf-1-5-dev,
 golang-github-google-btree-dev,
 golang-github-grpc-ecosystem-go-grpc-middleware-dev (>= 2.0),
 golang-github-grpc-ecosystem-go-grpc-prometheus-dev (>= 1.2.0+git20191002.6af20e3-5),
 golang-github-grpc-ecosystem-grpc-gateway-dev (>= 2.0),
 golang-github-jonboulle-clockwork-dev,
 golang-github-json-iterator-go-dev,
 golang-github-modern-go-reflect2-dev,
 golang-github-olekukonko-tablewriter-dev (>= 1.0),
 golang-github-prometheus-client-golang-dev (>= 1.0.0~),
 golang-github-prometheus-client-model-dev,
 golang-github-soheilhy-cmux-dev,
 golang-github-spf13-cobra-dev,
 golang-github-spf13-pflag-dev,
 golang-github-tmc-grpc-websocket-proxy-dev,
 golang-github-urfave-cli-dev,
 golang-github-xiang90-probing-dev (>= 0.0.1~),
 golang-go.uber-zap-dev,
 golang-golang-x-crypto-dev,
 golang-golang-x-net-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-time-dev,
 golang-google-grpc-dev (>= 1.64.0-5),
 golang-gopkg-cheggaaa-pb.v1-dev,
 golang-gopkg-natefinch-lumberjack.v2-dev,
 golang-gopkg-yaml.v2-dev,
 golang-k8s-sigs-yaml-dev,
 golang-opentelemetry-contrib-dev (>= 0.56),
 golang-opentelemetry-otel-dev (>= 1.31),
 ${misc:Depends},
Provides:
 golang-github-coreos-etcd-dev,
Breaks:
 golang-github-docker-docker-dev (<< 20.10.21+dfsg1-2~),
 golang-github-docker-libkv-dev (<< 0.2.1-4),
 golang-github-go-kit-kit-dev (<< 0.13.0-1),
 golang-github-minio-pkg-dev (<< 3.0.9-2),
 golang-github-xordataexchange-crypt-dev (<< 0.0.2+git20170626.21.b2862e3-4),
 nextcloud-spreed-signaling (<< 0.4.1-3~),
 vip-manager (<<1.0.2-5~),
Description: highly-available key value store -- source
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the source.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_EXCLUDES := \
	tools \
	tests/functional/cmd \
	contrib \
	# EOL
export DH_GOLANG_INSTALL_EXTRA := \
	$(shell find . -name fixtures-expired) \
	$(shell find . -name fixtures) \
	$(shell find . -name go.mod) \
	tests/functional/functional.yaml \
	# EOL

%:
	dh $@ --buildsystem=golang --builddirectory=_build

execute_after_dh_auto_build:
	mv -v _build/bin/server _build/bin/etcd
    # remove dangling symlinks. They are pointing to the "tests" package that
    # we exclude further up
	rm -vf _build/src/go.etcd.io/etcd/client/*/example_*.go

override_dh_auto_test:
	GOLANG_TEST_SHORT=true dh_auto_test -O--no-parallel -- -run=Test -short

execute_after_dh_auto_test:
	find _build -type s -delete

# Handle package name (etcd-server) != service name (etcd)
override_dh_installsystemd:
	dh_installsystemd -p etcd-server --name=etcd

# autopktest-pkg-go integration runs "debian/rules build", which is a no-op due
# to a script "build" present in the upstream source. This (PHONY) target
# overrides this.
build:
	dh build --buildsystem=golang --builddirectory=_build

.PHONY: build

=== debian/tests/control ===
Tests:
 integration,
Architecture: amd64
Depends:
 curl,
 etcd-client,
 etcd-server,
 procps,
 @builddeps@,
Restrictions:
 allow-stderr,
 breaks-testbed,
 isolation-container,
 needs-root,

Tests:
 functional,
Architecture: amd64
Depends:
 etcd-client,
 etcd-server,
 iproute2,
 netcat-openbsd,
 @builddeps@,
Restrictions:
 allow-stderr,
 isolation-container,

Tests:
 member-list
Architecture: any
Depends:
 etcd-client,
 etcd-server,
Restrictions:
 allow-stderr,
 isolation-container,

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/etcd-$1\.tar\.gz/ \
  https://github.com/etcd-io/etcd/tags .*/v?(\d\S+)\.tar\.gz

## etcd 3.5.18

=== debian/changelog ===
etcd (3.5.18-1) unstable; urgency=medium

  * Update to new etcd version 3.5.18

 -- root <root@518f705acfc8>  Thu, 13 Feb 2025 17:52:41 +0000

etcd (3.5.18-1) unstable; urgency=low
  * Initial Release.
 -- EvgeniyPatlan <evgeniy.patlan@percona.com> Thu, 13 Feb 2025 17:52:41 +0000

## etcd 3.5.21

=== debian/changelog ===
etcd (3.5.21-1) unstable; urgency=medium

  * Update to new etcd version 3.5.21

 -- root <root@c78436efc656>  Fri, 25 Apr 2025 09:13:21 +0000

etcd (3.5.21-1) unstable; urgency=low
  * Initial Release.
 -- EvgeniyPatlan <evgeniy.patlan@percona.com> Fri, 25 Apr 2025 09:13:21 +0000

=== debian/control ===
Source: etcd
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Jelmer Vernooij <jelmer@debian.org>,
           Tim Potter <tpot@hpe.com>,
           Anthony Fok <foka@debian.org>,
Section: net
Priority: optional
Build-Depends: debhelper,
               dh-golang
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/etcd
Vcs-Git: https://salsa.debian.org/go-team/packages/etcd.git
Homepage: https://etcd.io
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/coreos/etcd

Package: etcd
Architecture: all
Section: oldlibs
Depends: etcd-client,
         etcd-server,
         ${misc:Depends},
Description: Transitional package for etcd-client and etcd-server
 This is a transitional package to ease upgrades for splitting the
 etcd package into a separate client and server piece. It can be
 safely removed.

Package: etcd-server
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         lsb-base,
         pipexec,
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: etcd-client,
Built-Using: ${misc:Built-Using},
Description: highly-available key value store -- daemon
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the server binaries.

Package: etcd-client
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Built-Using: ${misc:Built-Using},
Description: highly-available key value store -- client
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the client binaries.

## etcd 3.5.22

=== Makefile ===
--- 
+++ 
@@ -156,7 +156,7 @@
 
 test-smoke:
 	$(info log-file: test-$(TEST_SUFFIX).log)
-	PASSES="fmt bom dep build unit" ./test.sh 2<&1 | tee test-$(TEST_SUFFIX).log
+	PASSES="dep build unit" ./test.sh 2<&1 | tee test-$(TEST_SUFFIX).log
 	! grep "FAIL:" test-$(TEST_SUFFIX).log
 
 test-full:
@@ -175,9 +175,21 @@
 test-e2e:
 	PASSES="build e2e" ./test.sh $(GO_TEST_FLAGS)
 
+.PHONY: test-grpcproxy-integration
+test-grpcproxy-integration:
+	PASSES='build grpcproxy_integration' RACE='true' ./test.sh $(GO_TEST_FLAGS)
+
+.PHONY: test-grpcproxy-e2e
+test-grpcproxy-e2e:
+	PASSES='build grpcproxy_e2e' RACE='true' ./test.sh $(GO_TEST_FLAGS)
+
 .PHONY: test-e2e-release
 test-e2e-release:
 	PASSES="build release e2e" ./test.sh $(GO_TEST_FLAGS)
+
+.PHONY: test-release
+test-release:
+	PASSES="release_tests" ./test.sh $(GO_TEST_FLAGS)
 
 ensure-docker-test-image-exists:
 	make pull-docker-test || ( echo "WARNING: Container Image not found in registry, building locally"; make build-docker-test )
@@ -366,14 +378,3 @@
 	  $(TMP_DIR_MOUNT_FLAG) \
 	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
 	  --mount type=bind,source=`pwd`/tests/docker-dns/certs,destination=/certs \
-	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
-	  /bin/bash -c "cd /etcd && /certs/run.sh && rm -rf m*.etcd"
-
-docker-dns-test-certs-gateway-run:
-	$(info GO_VERSION: $(GO_VERSION))
-	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
-	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
-	docker run \
-	  --rm \
-	  --tty \
-	  --dns 127.0.0.1 \

=== debian/changelog ===
etcd (3.5.22-2) experimental; urgency=medium

  * Revert "Drop init script"
  * Backport upstream patch that allows building with
    olekukonko/tablewriter version 1.0.6

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 16 Aug 2025 22:06:00 -0400

etcd (3.5.22-1) experimental; urgency=medium

  * Team upload.
  * New upstream release: 3.5.22
  * Drop sysv init script

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 15 Aug 2025 15:57:57 -0400

=== debian/rules ===
--- 
+++ 
@@ -29,6 +29,8 @@
 	find _build -type s -delete
 
 # Handle package name (etcd-server) != service name (etcd)
+override_dh_installinit:
+	dh_installinit -p etcd-server --name=etcd
 override_dh_installsystemd:
 	dh_installsystemd -p etcd-server --name=etcd

=== debian/tests/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
 Restrictions:
  allow-stderr,
  breaks-testbed,
+ flaky,
  isolation-container,
  needs-root,
 
@@ -24,14 +25,5 @@
  @builddeps@,
 Restrictions:
  allow-stderr,
+ flaky,
  isolation-container,
-
-Tests:
- member-list
-Architecture: any
-Depends:
- etcd-client,
- etcd-server,
-Restrictions:
- allow-stderr,
- isolation-container,
